#include "I2CKeypad.h"
#include <Wire.h>

I2CKEYPAD::I2CKEYPAD(int addr) {
  _Addr = addr;
  _PriorKey='\0';
}

char I2CKEYPAD::GetKey(){
int i, j, k;
unsigned char Mask;
unsigned char ColPin;
int ScanData;

  for(i=0; i<KPROWS; i++) {
    Mask = ~(unsigned char)(0x01 << _RowPins[i]);
    Write(Mask);
    ScanData = Read();
    if(ScanData != Mask) {
      ColPin = Mask ^ ScanData;
      for(j=0; j<KPCOLS; j++) {
        if((ColPin & (0x01 << j)) > 0) {
          for(k=0; k<KPCOLS; k++) {
            if(_ColPins[k] == j) {
              if(_Keys[i][k] != _PriorKey) {
                _PriorKey = _Keys[i][k];
                return _Keys[i][k];
              } else return '\0';
            }  
          }
        }
      }
    }
  }
  _PriorKey = '\0';
  return '\0';
}

void I2CKEYPAD::Write(int data) {
  Wire.beginTransmission(_Addr);
  Wire.write(data);
  Wire.endTransmission();
}

int I2CKEYPAD::Read() {
  Wire.requestFrom(_Addr, 1);
  return Wire.read();
}
